import numpy as np
from sklearn import datasets

def relu(t):
    return np.maximum(t, 0)

def softmax(t):
    out = np.exp(t)
    return out / np.sum(out)

def predict(x):
    t1 = x @ W1 + b1
    h1 = relu(t1)
    t2 = h1 @ W2 + b2
    z = softmax(t2)
    return z

INPUT_DIM = 4
OUT_DIM = 3
H_DIM = 3

with open("w1.npy", 'rb') as temp:
    W1=np.load(temp)
with open("b1.npy", 'rb') as temp:
    b1=np.load(temp)
with open("w2.npy", 'rb') as temp:
    W2=np.load(temp)
with open("b2.npy", 'rb') as temp:
    b2=np.load(temp)

# with open("vesi.npz") as temp:
#     all=np.load(temp)
#
# print(all.files)

# print(W1)
# print(b1)
# print(W2)
# print(b2)


# W1 = np.array([[ 0.71003792, -0.43817813],
#                 [ 1.349525,   -0.33465762],
#                 [-1.4898579,  -0.08198983],
#                 [-0.81645308,  0.29686873],])
#
# b1 =  np.array([[ 0.60844249, -0.32574063]])
#
# W2 = np.array([[ 1.16615745,  0.1909614,  -1.69807602],
#                 [-0.01595177, -0.54379735, -0.46152405]])
#
# b2 =  np.array([[-1.97700896,  0.77560055,  1.44466936]])

iris = datasets.load_iris()
dataset = []
for i in range(len(iris.target)):
    dataset.append((iris.data[[i]], iris.target[i]))

batch_x, batch_y = zip(*dataset)
xd = np.concatenate(batch_x, axis=0)
yd = np.array(batch_y)

correct=0

for i in range(len(dataset)):
    x = xd[i]
    y = yd[i]
    probs = predict(x)
    pred_class = np.argmax(probs)
    # print(y,pred_class)
    if pred_class==y:
        correct+=1
    class_names = ['Setosa', 'Versicolor', 'Virginica']
    # print('Predicted class:', class_names[pred_class])

print("Точность: ", correct/150)